## calligra 24.12.3+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

# KDE Applications version, managed by release script.
set(RELEASE_SERVICE_VERSION_MAJOR "24")
set(RELEASE_SERVICE_VERSION_MINOR "12")
set(RELEASE_SERVICE_VERSION_MICRO "3")
set(RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")

string(TIMESTAMP CALLIGRA_YEAR "%Y")
add_compile_options("-DCALLIGRA_YEAR=${CALLIGRA_YEAR}")

project(calligra VERSION ${RELEASE_SERVICE_VERSION})

if (POLICY CMP0071)
    cmake_policy(SET CMP0071 NEW)
endif()

set(REQUIRED_KF6_VERSION "6.0.0")
set(REQUIRED_QT_VERSION "6.5.0")

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

find_package(ECM ${REQUIRED_KF6_VERSION} REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/modules")

# ECM KDE macros (include first, to have their policies and settings effect all other macros)
include(KDEInstallDirs)
include(KDECMakeSettings NO_POLICY_SCOPE)
set(KDE_COMPILERSETTINGS_LEVEL 5.84.0) # set before including
include(KDECompilerSettings NO_POLICY_SCOPE)
# CMake macros
include(CMakePackageConfigHelpers)
include(WriteBasicConfigVersionFile)
include(CheckFunctionExists)
include(CheckTypeSize)
include(CheckIncludeFile)
include(GenerateExportHeader)
include(FeatureSummary)
# ECM macros
include(ECMOptionalAddSubdirectory)
include(ECMInstallIcons)
include(ECMAddAppIcon)
include(ECMSetupVersion)
include(ECMAddTests)
include(ECMMarkAsTest)
include(ECMMarkNonGuiExecutable)
include(ECMGenerateHeaders)
include(KDEClangFormat)
include(KDEGitCommitHooks)
# own macros
include(MacroBoolTo01)
include(MacroOptionalFindPackage)
include(MacroEnsureVersion)

math(EXPR GENERIC_CALLIGRA_LIB_VERSION_MAJOR "${RELEASE_SERVICE_VERSION_MAJOR} + 15")

ecm_setup_version(${PROJECT_VERSION}
    VARIABLE_PREFIX CALLIGRA
    VERSION_HEADER ${CMAKE_CURRENT_BINARY_DIR}/calligra-version.h
    SOVERSION ${GENERIC_CALLIGRA_LIB_VERSION_MAJOR}
)

############
#############
## Options ##
#############
############

option(PACKAGERS_BUILD "Build support of multiple CPU architectures in one binary. Should be used by packagers only." ON)

#######################
########################
## Productset setting ##
########################
#######################

# For predefined productsets see the definitions in CalligraProducts.cmake and
# in the files in the folder cmake/productsets.

# Finding out the products & features to build is done in 5 steps:
# 1. have the user define the products/features wanted, by giving a productset
# 2. estimate all additional required products/features
# 3. estimate which of the products/features can be build by external deps
# 4. find which products/features have been temporarily disabled due to problems
# 5. estimate which of the products/features can be build by internal deps

# get the special macros
include(CalligraProductSetMacros)

# get the definitions of products, features and product sets
include(CalligraProducts.cmake)

set(PRODUCTSET_DEFAULT "ALL")

if(NOT PRODUCTSET)
    set(PRODUCTSET ${PRODUCTSET_DEFAULT} CACHE STRING "Set of products/features to build" FORCE)
endif()

if (RELEASE_BUILD)
    set(CALLIGRA_SHOULD_BUILD_STAGING TRUE)
    set(CALLIGRA_SHOULD_BUILD_GEMINI FALSE)
    set(CALLIGRA_SHOULD_BUILD_BRAINDUMP FALSE)
    if(BUILD_UNMAINTAINED)
        set(CALLIGRA_SHOULD_BUILD_UNMAINTAINED TRUE)
    else()
        set(CALLIGRA_SHOULD_BUILD_UNMAINTAINED FALSE)
    endif()
else ()
    set(CALLIGRA_SHOULD_BUILD_STAGING TRUE)
    set(CALLIGRA_SHOULD_BUILD_UNMAINTAINED TRUE)
    set(CALLIGRA_SHOULD_BUILD_GEMINI TRUE)
    set(CALLIGRA_SHOULD_BUILD_BRAINDUMP TRUE)
endif ()

# finally choose products/features to build
calligra_set_productset(${PRODUCTSET})

##########################
###########################
## Look for ECM, Qt, KF6 ##
###########################
##########################

find_package(KF6 ${REQUIRED_KF6_VERSION} REQUIRED
    COMPONENTS
    Archive
    Completion
    Config
    ConfigWidgets
    CoreAddons
    Crash
    DocTools
    GuiAddons
    I18n
    IconThemes
    ItemViews
    JobWidgets
    KCMUtils
    KIO
    Notifications
    NotifyConfig
    Sonnet
    TextWidgets
    WidgetsAddons
    WindowSystem
    XmlGui
)

find_package(Qt6 ${REQUIRED_QT_VERSION} REQUIRED
    COMPONENTS
    Core
    Gui
    Network
    PrintSupport
    Svg
    Test
    Widgets
    Xml
    Quick
    QuickControls2
)
find_package(Qt6 ${REQUIRED_QT_VERSION} QUIET
    COMPONENTS
    OpenGL
    QuickWidgets
    Sql
    WebEngineWidgets
)

qt_policy(SET QTP0001 NEW)


find_package(OpenSSL)
set_package_properties(OpenSSL PROPERTIES
    TYPE REQUIRED
    PURPOSE "Encrypted communications"
)

set_package_properties(Qt6QuickWidgets PROPERTIES
    PURPOSE "Required for Calligra Gemini"
    TYPE RECOMMENDED
    )
set_package_properties(Qt6Sql PROPERTIES
    PURPOSE "Optional for Sheets' database connection"
    TYPE OPTIONAL
    )
set_package_properties(Qt6WebEngine PROPERTIES
    PURPOSE "Required for Braindump's Web shape"
    TYPE OPTIONAL
)

set(HAVE_OPENGL ${Qt6OpenGL_FOUND})

# use sane compile flags
remove_definitions(-DQT_DISABLE_DEPRECATED_BEFORE=0)
add_definitions(
    -DQT_USE_QSTRINGBUILDER
    -DQT_STRICT_ITERATORS
    -DQT_NO_SIGNALS_SLOTS_KEYWORDS
    -DQT_NO_URL_CAST_FROM_STRING
    -DQT_NO_CAST_TO_ASCII
    -DKF_DISABLE_DEPRECATED_BEFORE_AND_AT=0x053000
    -DQT_DISABLE_DEPRECATED_BEFORE=0x050600
    )

if(UNIX AND NOT APPLE AND NOT ANDROID AND NOT CALLIGRA_FLATPAK)
    add_definitions(-DWITH_QTDBUS)
    find_package(Qt6 ${REQUIRED_KF6_VERSION} REQUIRED
        COMPONENTS
        DBus
    )
    find_package(KF6 ${REQUIRED_KF6_VERSION} REQUIRED
        COMPONENTS
        DBusAddons
    )
endif()

# only with this definition will all the FOO_TEST_EXPORT macro do something
# TODO: check if this can be moved to only those places which make use of it,
# to reduce global compiler definitions that would trigger a recompile of
# everything on a change (like adding/removing tests to/from the build)
if(BUILD_TESTING)
    add_definitions(-DCOMPILING_TESTS)
endif()

# overcome some platform incompatibilities
if(WIN32)
    if(NOT MINGW)
	include_directories(${CMAKE_CURRENT_SOURCE_DIR}/winquirks)
	add_definitions(-D_USE_MATH_DEFINES)
	add_definitions(-DNOMINMAX)
    endif()
    set(WIN32_PLATFORM_NET_LIBS ws2_32.lib netapi32.lib)
endif()

###########################
############################
## Required dependencies  ##
############################
###########################

find_package(Perl REQUIRED)
find_package(ZLIB REQUIRED)

find_package(Qt6Keychain)
set_package_properties(Qt6Keychain PROPERTIES
    TYPE REQUIRED
    PURPOSE "Secure storage of account secrets"
)

add_definitions(-DBOOST_ALL_NO_LIB)
find_package(Boost REQUIRED) # for pigment and stage
if (NOT Boost_FOUND)
    message(FATAL_ERROR "Did not find Boost. Boost is required for the core libraries, stage, sheets.")
endif ()

###########################
############################
## Optional dependencies  ##
############################
###########################


##
## Check for OpenEXR
##

macro_optional_find_package(Imath 3.0 CONFIG QUIET)
if(TARGET Imath::Imath)
    set(OPENEXR_LIBRARIES Imath::Imath)
    set(OpenEXR_FOUND TRUE)
else()
    macro_optional_find_package(OpenEXR)
endif()
macro_bool_to_01(OpenEXR_FOUND HAVE_OPENEXR)

##
## Test for GNU Scientific Library
##
macro_optional_find_package(GSL 1.7)
set_package_properties(GSL_FOUND PROPERTIES
    DESCRIPTION "GNU Scientific Library"
    URL "https://www.gnu.org/software/gsl"
    PURPOSE "Required by Sheets' solver plugin"
    TYPE OPTIONAL
    )
macro_bool_to_01(GSL_FOUND HAVE_GSL)
configure_file(config-gsl.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-gsl.h )

##
## Test for Phonon4Qt6
##
find_package(Phonon4Qt6 QUIET)
set_package_properties(Phonon4Qt6 PROPERTIES
    DESCRIPTION "Abstraction lib for multimedia applications"
    URL "https://www.kde.org/"
    PURPOSE "Required by Stage event actions and Videoshape plugin"
    TYPE OPTIONAL
    )

## PIM libraries detection disabled until semanticitems plugin is ported to Qt6
##
## Test for KF6CalendarCore
##
# find_package(KF6CalendarCore CONFIG QUIET)
# set_package_properties(KF6CalendarCore PROPERTIES
#     DESCRIPTION "KDE Calendar Library"
#     URL "https://www.kde.org/"
#     PURPOSE "Optionally used by semantic item Event"
#     TYPE OPTIONAL
#     )
# 
##
## Test for KF6Contacts
##
# find_package(KF6Contacts CONFIG QUIET)
# set_package_properties(KF6Contacts PROPERTIES
#     DESCRIPTION "KDE Address book Library"
#     URL "https://www.kde.org/"
#     PURPOSE "Optionally used by semantic item Contact"
#     TYPE OPTIONAL
#     )
# 
##
## Test for KPim6AkonadiCore
##
# find_package(KPim6Akonadi CONFIG QUIET)
# set_package_properties(KFPimAkonadi PROPERTIES
#     DESCRIPTION "Library for general Access to Akonadi"
#     URL "https://www.kde.org/"
#     PURPOSE "Optionally used by semantic items Event and Contact"
#     TYPE OPTIONAL
#     )
# 
##
## Test for KChart
##
macro_optional_find_package(KChart6 3.0.0 QUIET)
set_package_properties(KChart6 PROPERTIES
    DESCRIPTION "Library for creating business charts (part of KDiagram)"
    URL "https://www.kde.org/"
    PURPOSE "Required by Chart shape"
    TYPE RECOMMENDED
)

##
## Test for eigen3
##
macro_optional_find_package(Eigen3)
set_package_properties(Eigen3 PROPERTIES
    DESCRIPTION "C++ template library for linear algebra"
    URL "http://eigen.tuxfamily.org"
    PURPOSE "Required by Calligra Sheets"
    TYPE RECOMMENDED
    )

##
## Test for QCA2
##
macro_optional_find_package(Qca-qt6 2.1.0 QUIET)
set_package_properties(Qca-qt6 PROPERTIES
    DESCRIPTION "Qt Cryptographic Architecture"
    URL "http:/download.kde.org/stable/qca-qt6"
    PURPOSE "Required for encrypted OpenDocument files and encrypted xls files support (available as a module in kdesupport)"
    TYPE OPTIONAL
    )

##
## Test for soprano
##
# QT5TODO: push for released (and maintained) Qt6 version of Soprano, T462, T461
# macro_optional_find_package(Soprano)
set(Soprano_FOUND FALSE)
set_package_properties(Soprano PROPERTIES
    DESCRIPTION "RDF handling library"
    URL "http://soprano.sourceforge.net/"
    PURPOSE "Required to handle RDF metadata in ODF"
    TYPE OPTIONAL
    )
if(NOT Soprano_FOUND)
    set(SOPRANO_INCLUDE_DIR "")
endif()

##
## Test for marble
##
# Temporary fix to avoid looking for Marble unnecessarily
# Its only used in RDF so until soprano is ported there is no use for Marble
if (Soprano_FOUND)
    macro_optional_find_package(Marble CONFIG)
    set(Marble_FOUND FALSE)
    set_package_properties(Marble PROPERTIES
        DESCRIPTION "World Globe Widget library"
        URL "https://marble.kde.org/"
        PURPOSE "Required by RDF to show locations on a map"
        TYPE OPTIONAL
    )
else()
    message(STATUS "Soprano not found. Skipped looking for Marble.")
endif()

##
## Test for lcms
##
macro_optional_find_package(LCMS2 2.4)
set_package_properties(LCMS2 PROPERTIES
    DESCRIPTION "LittleCMS, a color management engine"
    URL "http://www.littlecms.com"
    PURPOSE "Will be used for color management"
    TYPE OPTIONAL
    )
if(LCMS2_FOUND)
    set(HAVE_LCMS2 TRUE)
endif()

##
## Test for Vc
##

set(HAVE_VC FALSE)
if (BUILD_VC)
    # NOTE: This tampers with cmake variables (at least cmake_minimum_required), so may give build problems
    set(OLD_CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} )
    set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules )
    if( NOT MSVC)
	macro_optional_find_package(Vc 1.1.0)
	set_package_properties(Vc PROPERTIES
	    DESCRIPTION "Portable, zero-overhead SIMD library for C++"
	    URL "https://github.com/VcDevel/Vc"
	    PURPOSE "Required by the pigment for vectorization"
	    TYPE OPTIONAL
	    )
	macro_bool_to_01(Vc_FOUND HAVE_VC)
	macro_bool_to_01(PACKAGERS_BUILD DO_PACKAGERS_BUILD)
    endif()

=== stage/CMakeLists.txt ===
project(calligra-stage)

add_definitions(-DTRANSLATION_DOMAIN=\"calligrastage\")

include_directories(
    ${KOTEXT_INCLUDES}
    ${KOMAIN_INCLUDES}
)

if (SHOULD_BUILD_PART_STAGE)
    add_subdirectory( part )
    add_subdirectory( pics )
    add_subdirectory( templates )
    add_subdirectory( plugins )
    add_subdirectory( data )
    add_subdirectory( styles )
endif ()

if (SHOULD_BUILD_APP_STAGE)
    add_subdirectory( app )
endif ()

=== extras/quickprint/CMakeLists.txt ===

set( QUICK_PRINT_SERVICES
)

if( SHOULD_BUILD_APP_KARBON )
    set( QUICK_PRINT_SERVICES ${QUICK_PRINT_SERVICES} karbon_print.desktop )
endif()

if( SHOULD_BUILD_APP_SHEETS )
    set( QUICK_PRINT_SERVICES ${QUICK_PRINT_SERVICES} sheets_print.desktop )
endif()

if( SHOULD_BUILD_APP_STAGE )
    set( QUICK_PRINT_SERVICES ${QUICK_PRINT_SERVICES} stage_print.desktop )
endif()

if( SHOULD_BUILD_APP_WORDS )
    set( QUICK_PRINT_SERVICES ${QUICK_PRINT_SERVICES} words_print.desktop )
endif()

install( FILES ${QUICK_PRINT_SERVICES} DESTINATION ${KDE_INSTALL_DATADIR}/kio/servicemenus)

=== libs/pigment/tests/CMakeLists.txt ===
set( EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR} )

add_definitions(-DFILES_DATA_DIR="${CMAKE_CURRENT_SOURCE_DIR}/data/")

include_directories( ${PIGMENT_INCLUDES} ${CMAKE_CURRENT_SOURCE_DIR}/../colorspaces )

if(MSVC OR (WIN32 AND "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel"))
  # avoid "cannot open file 'LIBC.lib'" error
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /NODEFAULTLIB:LIBC.LIB")
endif()

# call: pigment_add_unit_test(<test-name> <sources> LINK_LIBRARIES <library> [<library> [...]] [GUI])
macro(PIGMENT_ADD_UNIT_TEST _TEST_NAME)
    ecm_add_test( ${ARGN}
        TEST_NAME "${_TEST_NAME}"
        NAME_PREFIX "libs-pigment-"
    )
endmacro()

########### next target ###############

pigment_add_unit_test(TestKoColorSpaceRegistry TestKoColorSpaceRegistry.cpp  LINK_LIBRARIES pigmentcms KF6::I18n Qt6::Test)

########### next target ###############

pigment_add_unit_test(TestColorConversion TestColorConversion.cpp  LINK_LIBRARIES pigmentcms Qt6::Test)

########### next target ###############

pigment_add_unit_test(TestKoColorSpaceAbstract TestKoColorSpaceAbstract.cpp  LINK_LIBRARIES pigmentcms KF6::I18n Qt6::Test)

########### next target ###############

pigment_add_unit_test(TestKoColorSpaceMaths TestKoColorSpaceMaths.cpp  LINK_LIBRARIES pigmentcms Qt6::Test)

########### next target ###############
set(CCSGraph_GRAPH CCSGraph.cpp)
add_executable(CCSGraph ${CCSGraph_GRAPH})
ecm_mark_as_test(CCSGraph)
target_link_libraries(CCSGraph  pigmentcms KF6::I18n )

########### next target ###############

pigment_add_unit_test(TestColorConversionSystem TestColorConversionSystem.cpp  LINK_LIBRARIES pigmentcms KF6::I18n Qt6::Test)

########### next target ###############

pigment_add_unit_test(TestKoColor TestKoColor.cpp  LINK_LIBRARIES pigmentcms KF6::I18n Qt6::Test)

########### next target ###############

pigment_add_unit_test(TestKoIntegerMaths TestKoIntegerMaths.cpp  LINK_LIBRARIES pigmentcms KF6::I18n Qt6::Test)

########### next target ###############

pigment_add_unit_test(TestConvolutionOpImpl TestConvolutionOpImpl.cpp  LINK_LIBRARIES pigmentcms KF6::I18n Qt6::Test)

########### next target ###############

pigment_add_unit_test(TestKoRgbU8ColorSpaceTester KoRgbU8ColorSpaceTester.cpp  LINK_LIBRARIES pigmentcms KF6::I18n Qt6::Test)

########### next target ###############

pigment_add_unit_test(TestKoColorSpaceSanity TestKoColorSpaceSanity.cpp  LINK_LIBRARIES pigmentcms KF6::I18n Qt6::Test)

########### next target ###############

pigment_add_unit_test(TestFallBackColorTransformation TestFallBackColorTransformation.cpp  LINK_LIBRARIES pigmentcms KF6::I18n Qt6::Test)

########### next target ###############

pigment_add_unit_test(TestKoChannelInfo TestKoChannelInfo.cpp  LINK_LIBRARIES pigmentcms KF6::I18n Qt6::Test)

=== plugins/textediting/thesaurus/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"calligra_textediting_thesaurus\")

include_directories( ${KOWIDGETS_INCLUDES} ${KOTEXT_INCLUDES} )

########### next target ###############

set(thesaurustool_SRCS
    ThesaurusDebug.cpp
    Thesaurus.cpp
    ThesaurusPlugin.cpp
    ThesaurusFactory.cpp
)


add_library(calligra_textediting_thesaurus MODULE ${thesaurustool_SRCS})

target_link_libraries(calligra_textediting_thesaurus
    kotext
    kowidgets
)

install(TARGETS calligra_textediting_thesaurus  DESTINATION ${KDE_INSTALL_PLUGINDIR}/calligra/textediting)


########### install files ###############

install( FILES  thesaurus.txt  DESTINATION ${KDE_INSTALL_DATADIR}/calligra/thesaurus)

=== filters/sheets/latex/export/CMakeLists.txt ===
include_directories(${KOMAIN_INCLUDES})

########### next target ###############

set(kspread2tex_PART_SRCS
   LatexDebug.cpp
   cell.cc 
   column.cc 
   config.cc 
   document.cc 
   fileheader.cc 
   format.cc 
   latexexportdialog.cc
   latexexport.cc 
   latexexportAdaptor.cc 
   map.cc 
   pen.cc 
   row.cc 
   spreadsheet.cc 
   table.cc 
   xmlparser.cc )

ki18n_wrap_ui(kspread2tex_PART_SRCS latexexportwidget.ui )

add_library(calligra_filter_kspread2tex MODULE ${kspread2tex_PART_SRCS})

target_link_libraries(calligra_filter_kspread2tex komain)

install(TARGETS calligra_filter_kspread2tex  DESTINATION ${KDE_INSTALL_PLUGINDIR}/calligra/formatfilters)

=== plugins/textediting/autocorrection/data/CMakeLists.txt ===

add_subdirectory(af_ZA)
add_subdirectory(bg_BG)
add_subdirectory(ca_ES)
add_subdirectory(cs_CZ)
add_subdirectory(da_DK)
add_subdirectory(de)
add_subdirectory(dsb)
add_subdirectory(el_GR)
add_subdirectory(en_AU)
add_subdirectory(en_GB)
add_subdirectory(en_US)
add_subdirectory(en_ZA)
add_subdirectory(fa_IR)
add_subdirectory(fi_FI)
add_subdirectory(ga_IE)
add_subdirectory(hr_HR)
add_subdirectory(hsb)
add_subdirectory(hu_HU)
add_subdirectory(is_IS)
add_subdirectory(it)
add_subdirectory(ja_JP)
add_subdirectory(ko_KR)
add_subdirectory(lb_LU)
add_subdirectory(lt_LT)
add_subdirectory(mn_MN)
add_subdirectory(nb)
add_subdirectory(nl_BE)
add_subdirectory(nl_NL)
add_subdirectory(nn)
add_subdirectory(pl_PL)
add_subdirectory(pt_BR)
add_subdirectory(pt_PT)
add_subdirectory(ro_RO)
add_subdirectory(ru_RU)
add_subdirectory(sk_SK)
add_subdirectory(sl_SI)
add_subdirectory(sr_CS)
add_subdirectory(sr_Latn_CS)
add_subdirectory(sr_Latn_ME)
add_subdirectory(sr_Latn_RS)
add_subdirectory(sr_ME)
add_subdirectory(sr_RS)
add_subdirectory(sv_SE)
add_subdirectory(tr_TR)
add_subdirectory(vi_VN)
add_subdirectory(vro_EE)
add_subdirectory(zh_CN)
add_subdirectory(zh_TW)

=== plugins/textediting/autocorrection/data/nl_BE/CMakeLists.txt ===
install(FILES nl_BE.xml DESTINATION ${KDE_INSTALL_DATADIR}/calligra/autocorrect)

=== plugins/textediting/autocorrection/data/sr_RS/CMakeLists.txt ===
install(FILES sr_RS.xml DESTINATION ${KDE_INSTALL_DATADIR}/calligra/autocorrect)

=== filters/words/rtf/import/3rdparty/rtf-qt/src/CMakeLists.txt ===
# To hide all the warnings from the generated itex2MML code
if (CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_GNUC)
    add_definitions(-Wno-unused-parameter)
endif ()


include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
)
#if(CMAKE_COMPILER_IS_GNUCXX)
#    list(APPEND CMAKE_CXX_FLAGS "-fprofile-arcs -ftest-coverage")
#    list(APPEND CMAKE_EXE_LINKER_FLAGS "-fprofile-arcs -ftest-coverage")
#endif()

set(RtfReader_LIB_SOURCES
        rtfdebug.cpp
	rtfreader.cpp
	controlword.cpp
	AbstractRtfOutput.cpp
	AuthorPcdataDestination.cpp
	CategoryPcdataDestination.cpp
	ColorTableDestination.cpp
	CommentPcdataDestination.cpp
	CompanyPcdataDestination.cpp
	Destination.cpp
	DocumentCommentPcdataDestination.cpp
	DocumentDestination.cpp
	FontTableDestination.cpp
	GeneratorPcdataDestination.cpp
	HLinkBasePcdataDestination.cpp
	IgnoredDestination.cpp
	InfoDestination.cpp
	InfoTimeDestination.cpp
	InfoCreatedTimeDestination.cpp
	InfoPrintedTimeDestination.cpp
	InfoRevisedTimeDestination.cpp
	KeywordsPcdataDestination.cpp
	ManagerPcdataDestination.cpp
	OperatorPcdataDestination.cpp
	PcdataDestination.cpp
	PictDestination.cpp
	SubjectPcdataDestination.cpp
	StyleSheetDestination.cpp
	TextDocumentRtfOutput.cpp
	TitlePcdataDestination.cpp
	Token.cpp
	Tokenizer.cpp
	UserPropsDestination.cpp
)

add_library(RtfReader SHARED ${RtfReader_LIB_SOURCES})
generate_export_header( RtfReader )

target_link_libraries(RtfReader Qt6::Gui)

set_target_properties(RtfReader PROPERTIES VERSION ${CALLIGRA_VERSION} SOVERSION ${CALLIGRA_SOVERSION} )
install(TARGETS RtfReader ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

=== debian/changelog ===
calligra (1:24.12.3+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.7.2, no changes required.
  * Update the patches:
    - upstream_appstream-fix-launchable-s-of-Sheets-and-Stage.patch: drop,
      backported from upstream
    - upstream_Ignore-calligra.desktop-for-AppStream.patch: drop, backported
      from upstream
    - upstream_sheets-fix-conflict-of-Value-int-and-Value-qsizetype.patch:
      drop, backported from upstream

 -- Pino Toscano <pino@debian.org>  Fri, 07 Mar 2025 07:27:11 +0100

=== debian/control ===
Source: calligra
Section: kde
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Pino Toscano <pino@debian.org>,
Build-Depends: cmake (>= 3.16~),
               debhelper-compat (= 13),
               dh-exec,
               extra-cmake-modules (>= 6.0.0~),
               gettext,
               libboost-dev,
               libeigen3-dev,
               libetonyek-dev,
               libfontconfig-dev,
               libfreetype-dev,
               libgsl-dev,
               libkchart-dev (>= 3.0.0~),
               libkf6archive-dev (>= 6.0.0~),
               libkf6completion-dev (>= 6.0.0~),
               libkf6config-dev (>= 6.0.0~),
               libkf6configwidgets-dev (>= 6.0.0~),
               libkf6coreaddons-dev (>= 6.0.0~),
               libkf6crash-dev (>= 6.0.0~),
               libkf6dbusaddons-dev (>= 6.0.0~),
               libkf6doctools-dev (>= 6.0.0~),
               libkf6guiaddons-dev (>= 6.0.0~),
               libkf6i18n-dev (>= 6.0.0~),
               libkf6iconthemes-dev (>= 6.0.0~),
               libkf6itemviews-dev (>= 6.0.0~),
               libkf6jobwidgets-dev (>= 6.0.0~),
               libkf6kcmutils-dev (>= 6.0.0~),
               libkf6kio-dev (>= 6.0.0~),
               libkf6notifications-dev (>= 6.0.0~),
               libkf6notifyconfig-dev (>= 6.0.0~),
               libkf6sonnet-dev (>= 6.0.0~),
               libkf6textwidgets-dev (>= 6.0.0~),
               libkf6widgetsaddons-dev (>= 6.0.0~),
               libkf6windowsystem-dev (>= 6.0.0~),
               libkf6xmlgui-dev (>= 6.0.0~),
               liblcms2-dev (>= 2.4),
               libodfgen-dev,
               libopenexr-dev,
               libphonon4qt6-dev,
               libphonon4qt6experimental-dev,
               libpoppler-private-dev (>= 22.02.0~),
               libpoppler-qt6-dev (>= 22.02.0~) [!i386],
               libqca-qt6-dev (>= 2.1.0~),
               librevenge-dev,
               libssl-dev,
               libvisio-dev (>= 0.1),
               libwpd-dev (>= 0.10),
               libwpg-dev (>= 0.3),
               libwps-dev (>= 0.4),
               okular-dev (>= 4:24.04.0~),
               pkg-kde-tools (>= 0.15.16),
               pkgconf,
               pstoedit,
               qt6-base-dev (>= 6.5.0~),
               qt6-declarative-dev (>= 6.5.0~),
               qtkeychain-qt6-dev,
               shared-mime-info,
               vc-dev (>= 1.1.0~) [any-amd64 any-i386 arm64 armel armhf],
               zlib1g-dev,
Standards-Version: 4.7.2
Homepage: https://www.calligra.org/
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/calligra.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/calligra
Rules-Requires-Root: no

Package: calligra
Architecture: any
Depends: calligrasheets (= ${binary:Version}),
         calligrastage (= ${binary:Version}),
         calligrawords (= ${binary:Version}),
         karbon (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Breaks: calligra-libs (<< 1:24.12.2+dfsg-2~),
Replaces: calligra-libs (<< 1:24.12.2+dfsg-2~),
Description: extensive productivity and creative suite
 Calligra Suite is a set of applications written to help you to accomplish
 your work. It includes office applications such as a word processor,
 a spreadsheet, a presentation program, a database application, etc., and
 raster and vector graphics tools.
 .
 This metapackage provides all the components of the Calligra Suite.

Package: karbon
Architecture: any
Section: graphics
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: pstoedit
Homepage: https://www.calligra.org/karbon/
Description: vector graphics application for the Calligra Suite
 Karbon is a vector drawing application with an user interface that is easy to
 use, highly customizable and extensible. That makes Karbon a great application
 for users starting to explore the world of vector graphics as well as for
 artists wanting to create breathtaking vector art. Features include:
 .
  * Loading support for ODG, SVG, WMF, WPG, EPS/PS
  * Writing support for ODG, SVG, WMF, PNG, PDF
  * Customizable user interface with freely placeable toolbars and dockers
  * Layer docker for easy handling of complex documents including preview
    thumbnails, support for grouping shapes via drag and drop,
    controlling visibility of shapes or locking
  * Advanced path editing tool with great on-canvas editing capabilities
  * Various drawing tools for creating path shapes including a draw path
    tool and a pencil tool, as well as a calligraphy drawing tool
  * Gradient and pattern tools for easy on-canvas editing of gradient and
    pattern styles
  * Top notch snapping facilities for guided drawing and editing (e.g.
    snapping to grid, guide lines, path nodes, bounding boxes, orthogonal
    positions, intersections of path shapes or extensions of lines and
    paths)
  * Many predefined basic shapes included, such as circle/ellipse, star or
    rectangle
  * Artistic text shape with support for following path outlines
    (i.e. text on path)
  * Complex path operations and effects like Boolean set operations,
    path flattening, rounding and refining as well as whirl/pinch effects
  * Extensible by writing plugins for new tools, shapes and dockers
 .
 This package is part of the Calligra Suite.

Package: calligrasheets
Architecture: any
Section: math
Depends: calligrasheets-data (>= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: khelpcenter,
Homepage: https://www.calligra.org/sheets/
Description: spreadsheet for the Calligra Suite
 Tables is a powerful spreadsheet application.  It is scriptable and
 provides both table-oriented sheets and support for complex mathematical
 formulae and statistics. It is the successor of KSpread.
 .
 This package is part of the Calligra Suite.

Package: calligrasheets-data
Architecture: all
Section: math
Depends: ${misc:Depends}
Homepage: https://www.calligra.org/sheets/
Description: data files for Sheets spreadsheet
 This package contains architecture-independent data files for Sheets,
 the spreadsheet shipped with the Calligra Suite.
 .
 See the calligrasheets package for further information.
 .
 This package is part of the Calligra Suite.

Package: calligrawords
Architecture: any
Section: text
Depends: calligrawords-data (>= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Homepage: https://www.calligra.org/words/
Description: word processor for the Calligra Suite
 Words is a FrameMaker-like word processing and desktop publishing
 application. It is capable of creating polished and professional
 looking documents. It can be used for desktop publishing, but also for
 "normal" word processing, like writing letters, reports and so on.
 .
 This package is part of the Calligra Suite.

Package: calligrawords-data
Architecture: all
Section: text
Depends: ${misc:Depends}
Homepage: https://www.calligra.org/words/
Description: data files for Words word processor
 This package contains architecture-independent data files for Words,
 the word processor shipped with the Calligra Suite.
 .
 See the calligrawords package for further information.
 .
 This package is part of the Calligra Suite.

Package: calligrastage
Architecture: any
Depends: calligrastage-data (>=${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: khelpcenter
Homepage: https://www.calligra.org/stage/
Description: presentation program for the Calligra Suite
 Stage is an easy to use yet still flexible presentation application. You can
 easily create presentations containing a rich variety of elements, from
 graphics to text, from charts to images. Stage is extensible through a
 plugin system, so it is easy to add new effects, new content elements or even
 new ways of managing your presentation.
 .
 Stage natively uses the OpenDocument file format standard, for easy
 interchange with all ODF supporting applications, which includes Microsoft
 Office. Examples of its easy-to-use features are support for layouts, a
 special slide overview view during presentations for the presenter, support
 for many different master sliders in one presentation, cool transitions and
 a useful notes feature.
 .
 This package is part of the Calligra Suite.

Package: calligrastage-data
Architecture: all
Depends: ${misc:Depends}
Homepage: https://www.calligra.org/stage/
Description: data files for Calligra Stage
 This package contains architecture-independent data files for Stage,
 the presentation program shipped with the Calligra Suite.
 .
 See the calligrastage package for further information.
 .
 This package is part of the Calligra Suite.

Package: calligra-libs
Section: libs
Architecture: any
Depends: calligra-data (>= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: fonts-lyx, libqca-qt6-plugins
Suggests: texlive, wordnet
Description: common libraries and binaries for the Calligra Suite
 This package provides the libraries and binaries that are shared amongst
 the various components of Calligra.
 .
 This package is part of the Calligra Suite.

Package: calligra-data
Section: libs
Architecture: all
Depends: ${misc:Depends}
Suggests: khelpcenter
Description: common shared data for the Calligra Suite
 This package provides the architecture-independent data that is shared
 amongst the various components of Calligra.
 .
 This package is part of the Calligra Suite.

Package: okular-backend-odp
Architecture: any
Section: graphics
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: okular
Enhances: okular
Description: Okular backend for ODP documents
 This package provides a backend for Okular to view OpenDocument Presentation
 (ODP) documents, but also PowerPoint and PPTX documents.
 .
 This package is part of the Calligra Suite.

Package: okular-backend-odt
Architecture: any
Section: graphics
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: okular
Enhances: okular
Description: Okular backend for ODT documents
 This package provides a backend for Okular to view OpenDocument Text
 (ODT) documents, but also DOC, DOCX, RTF and WPD documents.
 .
 This package is part of the Calligra Suite.

## calligra 25.04.0+dfsg

=== sheets/data/templates/CMakeLists.txt ===


add_subdirectory( General )
add_subdirectory( Business )
add_subdirectory( HomeFamily )

=== debian/changelog ===
calligra (1:25.04.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Update Vcs-* fields.

 -- Pino Toscano <pino@debian.org>  Sat, 26 Apr 2025 21:07:56 +0200

## calligra 25.04.1+dfsg

=== debian/changelog ===
calligra (1:25.04.1+dfsg-0ubuntu1) questing; urgency=medium

  * New upstream release (25.04.1)

 -- Rik Mills <rikmills@kde.org>  Thu, 08 May 2025 06:27:32 +0100

=== debian/control ===
--- 
+++ 
@@ -51,7 +51,7 @@
                libwpd-dev (>= 0.10),
                libwpg-dev (>= 0.3),
                libwps-dev (>= 0.4),
-               okular-dev (>= 4:24.04.0~),
+               okular-dev (>= 4:25.04.1~),
                pkg-kde-tools (>= 0.15.16),
                pkgconf,
                pstoedit,
@@ -63,8 +63,8 @@
                zlib1g-dev,
 Standards-Version: 4.7.2
 Homepage: https://www.calligra.org/
-Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/calligra.git
-Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/calligra
+Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/calligra.git
+Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/calligra
 Rules-Requires-Root: no
 
 Package: calligra

## calligra 25.04.2%2Bdfsg

=== braindump/CMakeLists.txt ===
project("braindump")

add_definitions(-DTRANSLATION_DOMAIN=\"braindump\")

include_directories ( ${CMAKE_CURRENT_SOURCE_DIR}/braindumpcore)

add_subdirectory(data)
add_subdirectory(src)
add_subdirectory(plugins)
add_subdirectory(braindumpcore)

=== filters/words/CMakeLists.txt ===
# check whether we can compile wv2

macro_optional_find_package(Iconv)
set_package_properties(Iconv PROPERTIES
    URL "http://www.gnu.org/software/libiconv/"
    PURPOSE "Required by the msword .doc filter"
    TYPE OPTIONAL
)

if( ICONV_FOUND )
    set( HAVE_ICONV_H 1 )
    set( ICONV_REQUIRES_CONST ${ICONV_SECOND_ARGUMENT_IS_CONST} )
endif()

check_include_file( sys/iconv.h HAVE_SYS_ICONV_H )

# Add "COMPILE_DEFINITIONS definitions" to TRY_RUN only if we have compile definitions

# Make sure ICONV_COMPILE_DEFINITIONS will never be empty (in case we define neither HAVE_ICONV_H nor HAVE_SYS_ICONV_H),
# otherwise TRY_RUN will fail due to COMPILE_DEFINITIONS being followed by nothing

set( ICONV_COMPILE_DEFINITIONS "-DBLAH" )

if( HAVE_ICONV_H )
  set( ICONV_COMPILE_DEFINITIONS ${ICONV_COMPILE_DEFINITIONS} "-DHAVE_ICONV_H" )
endif()

if( HAVE_SYS_ICONV_H )
  set( ICONV_COMPILE_DEFINITIONS ${ICONV_COMPILE_DEFINITIONS} "-DHAVE_SYS_ICONV_H" )
endif()

try_run( MODERN_ICONV_RUN MODERN_ICONV_COMPILE
         ${CMAKE_CURRENT_BINARY_DIR}/CMakeTmp
         ${CMAKE_SOURCE_DIR}/cmake/TestModernIconv.c
         CMAKE_FLAGS "-DLINK_LIBRARIES:STRING=${ICONV_LIBRARIES}"
                     "-DINCLUDE_DIRECTORIES:STRING=${ICONV_INCLUDE_DIR}"
         COMPILE_DEFINITIONS ${ICONV_COMPILE_DEFINITIONS} )

if( MODERN_ICONV_RUN GREATER 0 OR NOT MODERN_ICONV_COMPILE )
  message( STATUS "wv2 depends on a modern iconv installation, supporting UNICODELITTLE and" )
  message( STATUS "UNICODEBIG. The detected iconv version doesn't support these conversions." )
  message( STATUS "" )
  message( STATUS "Please get a new libiconv from http://www.gnu.org/software/libiconv/" )
  message( STATUS "You might want to install the library to some alternative directory, in" )
  message( STATUS "order not to overwrite your current installation. Please use the options" )
  message( STATUS "-DICONV_INCLUDE_DIR=DIR and -DICONV_LIBRARIES=DIR to specify the location." )
  message( STATUS "" )
  set(ICONV_FOUND FALSE)
endif()


include_directories(${KOMAIN_INCLUDES} )

if(SHOULD_BUILD_FILTER_APPLIXWORD_TO_ODT)
    add_subdirectory( applixword )
endif()

add_subdirectory( wordperfect )

add_subdirectory( works )

add_subdirectory( ascii )

add_subdirectory( wiki )

add_subdirectory( rtf )

add_subdirectory( epub )

if(SHOULD_BUILD_FILTER_ODT_TO_MOBI)
    add_subdirectory( mobi )
endif()

if(SHOULD_BUILD_FILTER_DOC_TO_ODT)
	if(NOT WIN32 AND NOT BSD) # FIXME
     add_subdirectory(msword-odf)
  endif()
endif()

if(SHOULD_BUILD_FILTER_DOCX_TO_ODT)
    add_subdirectory( docx )
endif()

=== sheets/plugins/calendar/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"calligrasheets_calendar\")

set(kspread_plugin_tool_calendar_SRCS
    CalendarTool.cpp
    CalendarToolFactory.cpp
    CalendarToolWidget.cpp
)

ki18n_wrap_ui(kspread_plugin_tool_calendar_SRCS CalendarToolWidget.ui)

add_library(kspread_plugin_tool_calendar MODULE ${kspread_plugin_tool_calendar_SRCS})

target_include_directories( kspread_plugin_tool_calendar
    PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}/../../
    ${CMAKE_CURRENT_BINARY_DIR}/../../
)


target_link_libraries(kspread_plugin_tool_calendar
    PUBLIC
    Qt6::Core
    calligrasheetspartlib
)

# TODO: calendar tool does not fit into UI anymore, needs rework. Thus not installing for now
#install(TARGETS kspread_plugin_tool_calendar DESTINATION ${KDE_INSTALL_PLUGINDIR}/calligrasheets/tools)
